# -*- coding: iso-8859-1 -*-
# Copyright (C) 2007-2013   EDF R&D
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
# See http://www.salome-platform.org/ or email : webmaster.salome@opencascade.com
#

class UN_PARMI:
   """
      La rgle vrifie que l'on trouve un des mots-cls
      de la rgle parmi les arguments d'un OBJECT.

      Ces arguments sont transmis  la rgle pour validation sous la forme
      d'une liste de noms de mots-cls ou d'un dictionnaire dont
      les cls sont des noms de mots-cls.
   """
   def verif(self,args):
      """
          La mthode verif vrifie que l'on trouve un des mos-cls
          de la liste self.mcs parmi les lments de args

          args peut etre un dictionnaire ou une liste. Les lments de args
          sont soit les lments de la liste soit les cls du dictionnaire.
      """
      #  on compte le nombre de mots cles presents
      text =''
      count=0
      args = self.liste_to_dico(args)
      for mc in self.mcs:
        if args.has_key(mc):count=count+1
      if count != 1:
          text = u"- Il faut un et un seul mot-cl parmi : "+`self.mcs`+'\n'
          return text,0
      return text,1

